Imports System.Net
Imports System.Text
Imports System.IO.Pipes

Public Class Client : Inherits CommunicationBase

   Private _Stream As PipeStream
   Private _Buf(&H400 - 1) As Byte

   Public Sub New(ByVal pipe As PipeStream)
      _Stream = pipe
      _Stream.BeginRead(_Buf, 0, _Buf.Length, AddressOf EndRead, Nothing)
   End Sub

   Private Sub EndRead(ByVal ar As IAsyncResult)
      If MyBase.IsDisposed Then Return
      Dim read As Integer = _Stream.EndRead(ar)
      If read = 0 Then 'leere Datenbermittlung signalisiert Verbindungsabbruch
         CrossThread.RunGui(AddressOf OnStatusMessage, _
            New MessageEventargs("CounterClient shut down"))
         CrossThread.RunGui(AddressOf MyBase.Dispose)
         Return
      End If
      Dim SB As New StringBuilder(Encoding.UTF8.GetString(_Buf, 0, read))
      While read = _Buf.Length
         read = _Stream.Read(_Buf, 0, _Buf.Length)
         SB.Append(Encoding.UTF8.GetString(_Buf, 0, read))
      End While
      CrossThread.RunGui(AddressOf OnChatMessage, New MessageEventargs(SB.ToString))
      _Stream.BeginRead(_Buf, 0, _Buf.Length, AddressOf EndRead, Nothing)
   End Sub

   Public Overrides Sub Send(ByVal Msg As String)
      Dim Buf() As Byte = Encoding.UTF8.GetBytes(Msg)
      _Stream.Write(Buf, 0, Buf.Length)
   End Sub

   Protected Overrides Sub Dispose(ByVal disposing As Boolean)
      _Stream.Dispose()
   End Sub

End Class
