Imports System.Net.Sockets
Imports System.Threading

''' <summary>
''' stellt den Erben "Server" und "Client" 2 verschiedene
''' Message-Events zur Verfgung, und ein Event-Raisendes Dispose
''' </summary>
Public MustInherit Class CommunicationBase : Implements IDisposable

   Private _IsDisposed As Boolean = False
   Public Event Disposed As EventHandlerEx(Of CommunicationBase)

   Protected MustOverride Sub Dispose(ByVal disposing As Boolean)
   Public MustOverride Sub Send(ByVal Msg As String)

   ''' <summary>
   ''' Zur Ausgabe chat-verwaltungstechnischer Status-Informationen
   ''' </summary>
   Public Event StatusMessage As EventHandler(Of MessageEventargs)
   Protected Sub OnStatusMessage(ByVal e As MessageEventargs)
      RaiseEvent StatusMessage(Me, e)
   End Sub

   ''' <summary>Zur Ausgabe von Chat-Messages</summary>
   Public Event ChatMessage As EventHandler(Of MessageEventargs)
   Protected Sub OnChatMessage(ByVal e As MessageEventargs)
      RaiseEvent ChatMessage(Me, e)
   End Sub

   Public Sub RemoveFrom(Of T As CommunicationBase)(ByVal Coll As ICollection(Of T))
      Coll.Remove(DirectCast(Me, T))
   End Sub

   Public ReadOnly Property IsDisposed() As Boolean
      Get
         Return _IsDisposed
      End Get
   End Property


   Public Sub AddTo(Of T As CommunicationBase)(ByVal Coll As ICollection(Of T))
      Coll.Add(DirectCast(Me, T))
   End Sub

   Public Sub Dispose() Implements IDisposable.Dispose
      If _IsDisposed Then Return
      _IsDisposed = True
      Dispose(True)           ' rufe die erzwungenen berschreibungen von Sub Dispose(Boolean)
      OnStatusMessage(New MessageEventargs(Me.GetType.Name, " disposed"))
      RaiseEvent Disposed(Me)
      GC.SuppressFinalize(Me)
   End Sub

End Class
