Imports System.Net
Imports System.IO.Pipes

Public Class Server : Inherits CommunicationBase

   'Pro Verbindung(sanfrage) wird ein Client-Objekt generiert, das den Datenaustausch dieser Verbindung abwickelt
   Private _Clients As New List(Of Client)

   Private _Name As String

   Public Sub New(ByVal name As String)
      _Name = name
      CreateWaitingStream()
   End Sub

   Private Sub CreateWaitingStream()
      Dim strm = New NamedPipeServerStream(_Name, PipeDirection.InOut, 20, PipeTransmissionMode.Byte, PipeOptions.Asynchronous)
      strm.BeginWaitForConnection(AddressOf EndAccept, strm)
   End Sub

   Sub EndAccept(ByVal ar As IAsyncResult)
      Dim strm = DirectCast(ar.AsyncState, NamedPipeServerStream)
      strm.EndWaitForConnection(ar)
      If MyBase.IsDisposed Then strm.Dispose() : Return
      With New Client(strm)
         AddHandler .ChatMessage, AddressOf Client_ChatMessage
         AddHandler .StatusMessage, AddressOf Client_StatusMessage
         AddHandler .Disposed, AddressOf Client_Disposed
         .AddTo(_Clients)
      End With
      CrossThread.RunGui(AddressOf OnStatusMessage, New MessageEventargs("Client accepted"))
      CreateWaitingStream()
   End Sub

#Region "_Clients-Ereignisverarbeitung"

   Private Sub Client_Disposed(ByVal Sender As CommunicationBase)
      'den Client fr die beendete Verbindung entfernen
      Sender.RemoveFrom(_Clients)
   End Sub

   Private Sub Client_ChatMessage(ByVal sender As Object, ByVal e As MessageEventargs)
      'einkommende ChatMessages anzeigen, und an alle versenden
      Send(e.Message)
   End Sub

   Private Sub Client_StatusMessage(ByVal sender As Object, ByVal e As MessageEventargs)
      'einkommende StatusMessages durchreichen (zur Anzeige)
      OnStatusMessage(e)
   End Sub

#End Region '_Clients-Ereignisverarbeitung

   Public Overrides Sub Send(ByVal Msg As String)
      OnChatMessage(New MessageEventargs(Msg)) ' anzeigen
      For Each C As Client In _Clients    ' an alle versenden
         C.Send(Msg)
      Next
   End Sub

   Protected Overrides Sub Dispose(ByVal disposing As Boolean)
      Using clnt = New NamedPipeClientStream(_Name)
         'Herstellen einer Dummi-Verbindung, damit der ServerStream aus dem Wartezustand herauskommt.
         clnt.Connect()
      End Using
      For i As Integer = _Clients.Count - 1 To 0 Step -1
         _Clients(i).Dispose()
      Next
   End Sub

End Class
